[USACO 2016 Dec Gold] Tutorial
Link:
A:
贪心从小到大插入,用并查集维护连通性
#include <bits/stdc++.h> using namespace std;
#define X first
#define Y second
typedef double db;
typedef long long ll;
typedef pair<int,int> P;
const int MAXN=1e3+;
int n,tot,cnt,f[MAXN];P dat[MAXN];
struct edge{int x,y;ll w;}e[MAXN*MAXN]; ll sqr(int x){return 1ll*x*x;}
bool cmp(edge x,edge y){return x.w<y.w;}
int find(int x){return f[x]==x?x:f[x]=find(f[x]);} int main()
{
scanf("%d",&n);
for(int i=;i<=n;i++)
scanf("%d%d",&dat[i].X,&dat[i].Y),f[i]=i;
for(int i=;i<n;i++)
for(int j=i+;j<=n;j++)
e[++tot]={i,j,sqr(dat[i].X-dat[j].X)+sqr(dat[i].Y-dat[j].Y)};
sort(e+,e+tot+,cmp); cnt=n;
for(int i=;i<=tot;i++)
{
int px=find(e[i].x),py=find(e[i].y);
if(px!=py) f[px]=py,cnt--;
if(cnt==) return printf("%lld",e[i].w),;
}
return ;
}
Problem A
B:
$dp[1...n][1...m][0/1]$,其中0/1表示当前在哪一边
#include <bits/stdc++.h> using namespace std;
#define X first
#define Y second
typedef double db;
typedef long long ll;
typedef pair<int,int> P;
const int MAXN=1e3+,INF=0x3f3f3f3f;
ll dp[MAXN][MAXN][];
int n,m;P dat[MAXN*]; ll sqr(int x){return 1ll*x*x;}
ll dist(int a,int b){return sqr(dat[a].X-dat[b].X)+sqr(dat[a].Y-dat[b].Y);} int main()
{
scanf("%d%d",&n,&m);
for(int i=;i<=n+m;i++)
scanf("%d%d",&dat[i].X,&dat[i].Y); memset(dp,0x3f,sizeof(dp));
dp[][][]=;
for(int i=;i<=n;i++)
for(int j=;j<=m;j++)
for(int k=;k<;k++)
{
if(i) dp[i+][j][]=min(dp[i+][j][],dp[i][j][]+dist(i,i+));
if(j) dp[i+][j][]=min(dp[i+][j][],dp[i][j][]+dist(n+j,i+));
if(i) dp[i][j+][]=min(dp[i][j+][],dp[i][j][]+dist(i,n+j+));
if(j) dp[i][j+][]=min(dp[i][j+][],dp[i][j][]+dist(n+j,n+j+));
}
printf("%lld",dp[n][m][]);
return ;
}
Problem B
C:
可以明显发现是最短路模型,但如果将一个点能不转弯走到的所有点的边都连上明显$TLE$
那么在跑最短路时多记录一维当前方向即可,每次转移判断是否要转向来决定是否增加代价
这样只要与不穿过其他点就能到达的点连边就行了
#include <bits/stdc++.h> using namespace std;
#define X first
#define Y second
typedef double db;
typedef long long ll;
typedef pair<int,int> P;
const int MAXN=1e5+,INF=0x3f3f3f3f;
int n,x,y,h1[MAXN],h2[MAXN],dist[MAXN][],tot;
struct edge{int nxt,to;}e1[MAXN<<],e2[MAXN<<];
struct node{int x,y,id;}tmp[MAXN],dat[MAXN];
struct Queue{int w,x,dir;}; bool cmp1(node a,node b){return a.x<b.x;}
bool cmp2(node a,node b){return a.y<b.y;}
bool operator < (Queue a,Queue b){return a.w>b.w;}
void add1(int x,int y)
{
e1[++tot]={h1[x],y};h1[x]=tot;
e1[++tot]={h1[y],x};h1[y]=tot;
}
void add2(int x,int y)
{
e2[++tot]={h2[x],y};h2[x]=tot;
e2[++tot]={h2[y],x};h2[y]=tot;
}
priority_queue<Queue> q; int main()
{
scanf("%d",&n);n+=;
scanf("%d%d",&x,&y);dat[]=tmp[]={x,y,};
scanf("%d%d",&x,&y);dat[n]=tmp[n]={x,y,n};
for(int i=;i<n;i++)
scanf("%d%d",&dat[i].x,&dat[i].y),dat[i].id=i,tmp[i]=dat[i]; sort(tmp+,tmp+n+,cmp1);
for(int i=;i<n;i++)
if(tmp[i].x==tmp[i+].x)
add1(tmp[i].id,tmp[i+].id);
sort(tmp+,tmp+n+,cmp2);
for(int i=;i<n;i++)
if(tmp[i].y==tmp[i+].y)
add2(tmp[i].id,tmp[i+].id); memset(dist,0x3f,sizeof(dist));
dist[][]=dist[][]=;
q.push(Queue{,,});q.push(Queue{,,});
while(!q.empty())
{
Queue t=q.top();q.pop();
if(dist[t.x][t.dir]<t.w) continue; for(int i=h1[t.x];i;i=e1[i].nxt)
if(dist[e1[i].to][]>dist[t.x][t.dir]+(t.dir!=))
dist[e1[i].to][]=dist[t.x][t.dir]+(t.dir!=),q.push(Queue{dist[e1[i].to][],e1[i].to,});
for(int i=h2[t.x];i;i=e2[i].nxt)
if(dist[e2[i].to][]>dist[t.x][t.dir]+(t.dir!=))
dist[e2[i].to][]=dist[t.x][t.dir]+(t.dir!=),q.push(Queue{dist[e2[i].to][],e2[i].to,});
}
int res=min(dist[n][],dist[n][]);
printf("%d",res==INF?-:res);
return ;
}
Problem C
不过看了题解发现由于:
1、同一行/列可以直达任一点
2、每次代价增加必然是行列间转化
从而也可以仅考虑坐标,离散化后对于点$(x,y)$将$x$行和$y$列连边即可
[USACO 2016 Dec Gold] Tutorial的更多相关文章
- [USACO 2017 Dec Gold] Tutorial
Link: USACO 2017 Dec Gold 传送门 A: 为了保证复杂度明显是从终结点往回退 结果一开始全在想优化建边$dfs$……其实可以不用建边直接$multiset$找可行边跑$bfs$ ...
- [USACO 2018 Feb Gold] Tutorial
Link: USACO 2018 Feb Gold 传送门 A: $dp[i][j][k]$表示前$i$个中有$j$个0且末位为$k$的最优解 状态数$O(n^3)$ #include <bit ...
- [USACO 2018 Jan Gold] Tutorial
Link: USACO 2018 Jan Gold 传送门 A: 对于不同的$k$,发现限制就是小于$k$的边不能走 那么此时的答案就是由大于等于$k$的边形成的图中$v$所在的连通块除去$v$的大小 ...
- Usaco 2010 Dec Gold Exercise(奶牛健美操)
/*codevs 3279 二分+dfs贪心检验 堆版本 re一个 爆栈了*/ #include<cstdio> #include<queue> #include<cst ...
- BZOJ1774[USACO 2009 Dec Gold 2.Cow Toll Paths]——floyd
题目描述 跟所有人一样,农夫约翰以着宁教我负天下牛,休叫天下牛负我的伟大精神,日日夜夜苦思生 财之道.为了发财,他设置了一系列的规章制度,使得任何一只奶牛在农场中的道路行走,都 要向农夫约翰上交过路费 ...
- BZOJ1775[USACO 2009 Dec Gold 3.Video Game Troubles]——DP
题目描述 输入 * 第1行: 两个由空格隔开的整数: N和V * 第2到第N+1行: 第i+1行表示第i种游戏平台的价格和可以在这种游戏平台上面运行的游 戏.包含: P_i, G_i还有G_i对由空格 ...
- [USACO 2017 Open Gold] Tutorial
Link: 传送门 A: 由于每个颜色只染色一次就确定了所有要染色的区间 要求染色的次数其实就是求区间最多嵌套多少层,如果有区间相交则无解 以上操作明显可以将左端点排序后用栈来维护 #include ...
- [USACO 2017 Feb Gold] Tutorial
Link: 传送门 A: 分层图最短路(其实就是最短路转移时多记录一维的数据 #include <bits/stdc++.h> using namespace std; #define X ...
- [USACO 2017 Jan Gold] Tutorial
Link: 传送门 A: 按值大小插入后用树状数组统计两边个数 #include <bits/stdc++.h> using namespace std; #define X first ...
随机推荐
- 五分钟学习Java8的流编程
1.概述 Java8中在Collection中增加了一个stream()方法,该方法返回一个Stream类型.我们就是用该Stream来进行流编程的: 流与集合不同,流是只有在按需计算的,而集合是已经 ...
- 20151024_002_C#基础知识(ArrayList,Hashtable,List,Dictionary)
1:ArrayList 和 Hashtable(哈希表) 1.1:ArrayList ArrayList list = new ArrayList(); list.Add(); list.AddRan ...
- 伪病毒 Rp_test
第一个写的对电脑有破坏性的程序= =,然后发现写system的copy的时候不会用字符串替代路径,然后就萎了= =,只能写一个没有自身复制的伪病毒了,坑到了好多同学的电脑,23333.... //By ...
- Vue 双向绑定原理
Vue.js最核心的功能有两个,一是响应式的数据绑定系统,二是组件系统. 一.访问器属性:Object.defineProperty ECMAScript 262v5带来的新东西,FF把它归入为jav ...
- PHP序列化、反序列化常用的魔术方法
__wakeup() //使用unserialize时触发__sleep() //使用serialize时触发__destruct() //对象被销毁时触发__call() //在对象上下文中调用不可 ...
- 微信支付:curl 出错,错误码: 60
在测试微信支付 - 模式二 - 扫码支付时,遇到如下错误: curl出错,错误码:60 这是因为在 WxPay.Api.php 文件中做了严格的 ssl 证书校验: curl_setopt($ch,C ...
- 設定 gpio 為 讀取用途,需注意的參數
Schematic 解說 上面的 線路圖, R1 R2 只能有一個被接上, R3 R4 只能有一個被接上, 是使用 gpio 讀取 電壓 判斷為0 或是 1 這時的 gpio 設定,其中一個參數需設為 ...
- linux===Ubuntu 上安装 Node.js
https://www.cnblogs.com/andfly/p/6681487.html
- [session篇]看源码学习session(一)
假如你是使用过或学习过PHP,你一定觉得很简单.session只不过是$_SESSION就可以搞得,这还不简单只是对一个key-value就能工作了.我觉得可以大多数的phper都是这样的,这是语言本 ...
- MSCL超级工具类(C#),开发人员必备,开发利器
MSCL超强工具类库 是基于C#开发的超强工具类集合,涵盖了日常B/S或C/S开发的诸多方面,包含上百个常用封装类(数据库操作类全面支持Mysql.Access.Oracle.Sqlserver.Sq ...